Debian Bug report logs - #493095
aborted lenny upgrade with nfs mount

version graph

Package: mount; Maintainer for mount is LaMont Jones <lamont@debian.org>; Source for mount is src:util-linux.

Reported by: "Alexandra N. Kossovsky" <sasha@oktetlabs.ru>

Date: Thu, 31 Jul 2008 10:54:01 UTC

Severity: important

Tags: wontfix

Merged with 498350, 501480

Found in version util-linux/2.13.1.1-1

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. Full text and rfc822 format available.

Acknowledgement sent to "Alexandra N. Kossovsky" <sasha@oktetlabs.ru>:
New Bug report received and forwarded. Copy sent to LaMont Jones <lamont@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Alexandra N. Kossovsky" <sasha@oktetlabs.ru>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: aborted lenny upgrade with nfs mount
Date: Thu, 31 Jul 2008 14:50:53 +0400
Package: mount
Version: 2.13.1.1-1
Severity: important

Hello.

I've started to upgrade my Debian Etch boxes to Lenny, and each time
I got "aptitude dist-upgrade" broken.  When aptitude tries to upgrade
mount, it fails with:
-----------------
You have NFS mount points currently mounted, and this version of mount
requires that nfs-common be upgraded before NFS mounts will work.

Aborting install.
-----------------
Well, I do have NFS mounts, and it is great to avoid breaking them, but
as far as I can see, aptitude has no hints like "upgrade nfs-common
before mount".

I think that mount should "Conflicts: nfs-common < 1:1.0.9" or something
like it.  If such approach is not possible, please, put some words about
this issue in release notes (sorry, I've failed to find Lenny release
notes -- may be, such information is already here).

This bug is very user-unfriendly, because broken "aptitude dist-upgrade"
is a hard thing to resolve for an ordinary user...

Thank you for your work,
    Alexandra.

-- System Information:
Debian Release: lenny/sid
  APT prefers testing
  APT policy: (900, 'testing'), (50, 'experimental'), (50, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.25-2-amd64 (SMP w/2 CPU cores)
Locale: LANG=, LC_CTYPE=ru_RU.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages mount depends on:
ii  libblkid1                     1.41.0-3   block device id library
ii  libc6                         2.7-10     GNU C Library: Shared libraries
ii  libselinux1                   2.0.59-1   SELinux shared libraries
ii  libuuid1                      1.41.0-3   universally unique id library

mount recommends no packages.

Versions of packages mount suggests:
ii  nfs-common                    1:1.1.2-6  NFS support files common to client

-- debconf-show failed

-- 
Regards,
        Sasha.
Alexandra N. Kossovsky, software engineer.
e-mail: sasha@sanechka.spb.ru




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#493095; Package mount. Full text and rfc822 format available.

Acknowledgement sent to LaMont Jones <lamont@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #10 received at 493095@bugs.debian.org (full text, mbox):

From: LaMont Jones <lamont@debian.org>
To: "Alexandra N. Kossovsky" <sasha@oktetlabs.ru>, 493095@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#493095: aborted lenny upgrade with nfs mount
Date: Thu, 31 Jul 2008 21:07:05 -0600
tag 493095 + wontfix
--

On Thu, Jul 31, 2008 at 02:50:53PM +0400, Alexandra N. Kossovsky wrote:
> Well, I do have NFS mounts, and it is great to avoid breaking them, but
> as far as I can see, aptitude has no hints like "upgrade nfs-common
> before mount".

Exactly.  Post lenny, we get 'Breaks:' which would do the right thing,
and isn't usable in lenny.

> I think that mount should "Conflicts: nfs-common < 1:1.0.9" or something
> like it.  If such approach is not possible, please, put some words about
> this issue in release notes (sorry, I've failed to find Lenny release
> notes -- may be, such information is already here).

The conflicts option you have would result in the removal of nfs-common,
which would (1) not fix the problem and (2) remove things you might
otherwise want.

As far as I know, the release notes for Lenny will include a "install
nfs-utils prior to upgrading mount" note.

> This bug is very user-unfriendly, because broken "aptitude dist-upgrade"
> is a hard thing to resolve for an ordinary user...

The ordinary user is not using NFS.  Given all of the options (the last
one being to force-install portmap and nfs on every machine in the
Debian universe - not a viable option unless I want to turn in my
security badge), the conclusion of several developers, the security
team, and the release team, was that the best option was to assert that
users of NFS were clever enough to fix the issue themselves, or had
someone who was that was managing their upgrades.

So, in short: yeah, it's a bug, it sucks, and the bug of aborting in the
preinst and thereby assuring a working system that a competent admin can
fix, is the best solution available to the problem at hand.

lamont




Tags added: wontfix Request was from LaMont Jones <lamont@debian.org> to control@bugs.debian.org. (Fri, 01 Aug 2008 03:09:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. Full text and rfc822 format available.

Acknowledgement sent to Holger Levsen <holger@layer-acht.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. Full text and rfc822 format available.

Message #17 received at 493095@bugs.debian.org (full text, mbox):

From: Holger Levsen <holger@layer-acht.org>
To: 493095@bugs.debian.org
Subject: fix it with pre-depends?
Date: Sun, 24 Aug 2008 20:48:19 +0200
[Message part 1 (text/plain, inline)]
Hi,

can't this be fixed with a versioned pre-depends on nfs-utils?


regards,
	Holger
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#493095; Package mount. Full text and rfc822 format available.

Acknowledgement sent to LaMont Jones <lamont@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #22 received at 493095@bugs.debian.org (full text, mbox):

From: LaMont Jones <lamont@debian.org>
To: Holger Levsen <holger@layer-acht.org>, 493095@bugs.debian.org
Subject: Re: Bug#493095: fix it with pre-depends?
Date: Mon, 25 Aug 2008 06:00:58 -0600
On Sun, Aug 24, 2008 at 08:48:19PM +0200, Holger Levsen wrote:
> can't this be fixed with a versioned pre-depends on nfs-utils?

Unacceptable to the security crowd, as this would result in every lenny
machine on the planet having portmapper installed and running...

What we really need is a versioned Breaks, which is supported by dpkg as
of lenny, and therefore usable for lenny+1.  Alas, not for lenny.

lamont




Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. Full text and rfc822 format available.

Acknowledgement sent to Anthony DeRobertis <aderobertis@metrics.net>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. Full text and rfc822 format available.

Message #27 received at 493095@bugs.debian.org (full text, mbox):

From: Anthony DeRobertis <aderobertis@metrics.net>
To: 493095@bugs.debian.org
Subject: Why isn't that usable for lenny?
Date: Wed, 17 Sep 2008 13:26:30 -0400
Don't we tell people in the release notes to upgrade aptitude, apt, and
dpkg first? In that case, shouldn'
't Breaks: be usable for lenny?





Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#493095; Package mount. (Fri, 19 Sep 2008 16:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to LaMont Jones <lamont@debian.org>:
Extra info received and forwarded to list. (Fri, 19 Sep 2008 16:57:03 GMT) Full text and rfc822 format available.

Message #32 received at 493095@bugs.debian.org (full text, mbox):

From: LaMont Jones <lamont@debian.org>
To: Anthony DeRobertis <aderobertis@metrics.net>, 493095@bugs.debian.org
Subject: Re: Bug#493095: Why isn't that usable for lenny?
Date: Fri, 19 Sep 2008 10:53:24 -0600
On Wed, Sep 17, 2008 at 01:26:30PM -0400, Anthony DeRobertis wrote:
> Don't we tell people in the release notes to upgrade aptitude, apt, and
> dpkg first? In that case, shouldn'
> 't Breaks: be usable for lenny?

See section 7.3 of Debian Policy.  We can use it once Lenny is released,
not before.

lamont




Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. (Fri, 19 Sep 2008 18:12:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Anthony DeRobertis <aderobertis@metrics.net>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Fri, 19 Sep 2008 18:12:02 GMT) Full text and rfc822 format available.

Message #37 received at 493095@bugs.debian.org (full text, mbox):

From: Anthony DeRobertis <aderobertis@metrics.net>
To: 493095@bugs.debian.org
Subject: Re: Bug#493095: Why isn't that usable for lenny?
Date: Fri, 19 Sep 2008 14:09:46 -0400
On 09/19/2008 12:53 PM, LaMont Jones wrote:
> See section 7.3 of Debian Policy.  We can use it once Lenny is released,
> not before.
That section of policy doesn't provide a rationale; it seems it is here:

http://lists.debian.org/debian-policy/2007/12/msg00152.html

Old dpkg will refuse to install packages which include a Breaks: header.




Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. (Mon, 13 Oct 2008 20:54:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Michael Gilbert" <michael.s.gilbert@gmail.com>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Mon, 13 Oct 2008 20:54:02 GMT) Full text and rfc822 format available.

Message #42 received at 493095@bugs.debian.org (full text, mbox):

From: "Michael Gilbert" <michael.s.gilbert@gmail.com>
To: 493095@bugs.debian.org
Subject: Re: Bug#493095: Why isn't that usable for lenny?
Date: Mon, 13 Oct 2008 16:53:18 -0400
couldn't you always halt the nfs daemon during mount's preinst
(similar to dbus and
other services during their upgrades)?  then reactivate during postinst?




Forcibly Merged 493095 501480. Request was from LaMont Jones <lamont@debian.org> to control@bugs.debian.org. (Sun, 21 Dec 2008 00:12:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. (Wed, 11 Feb 2009 16:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ken Chase <m-bugs.debian.org@sizone.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Wed, 11 Feb 2009 16:09:02 GMT) Full text and rfc822 format available.

Message #49 received at 493095@bugs.debian.org (full text, mbox):

From: Ken Chase <m-bugs.debian.org@sizone.org>
To: 493095@bugs.debian.org
Subject: Re: Bug#493095: no solution for diskless workstations
Date: Wed, 11 Feb 2009 11:07:04 -0500
Cant deactivate NFS on a diskless box.

Diskless workstations can't upgrade lenny (or sid at this point).

And I can't even chroot into the diskless tree on the server
because /proc will expose mounts. (Maybe if I run the tree
as a vserver it wont see the mounts and will work...hmm...)

I think my work around will be hacking the install script, or just
futzing with /etc/mtab for a few seconds to fool the script! Kludge win!

Judging by the solutions suggested in previous messages, using NFS is
some sort of low-skill admin style and should be avoided.

Reality however is that diskless workstations are less than entirely uncommon,
and a proper solution would be nice. (I mean, pretty much everything else
works for upgrading on a diskless box - I just did a huge dist-upgrade of 400+
packages that all worked except mount, why not fix the one package?)

/kc
-- 
Ken Chase - ken@heavycomputing.ca - 416 897 6284
Heavy Computing - Clueful Server Colocation at 151 Front St. W Toronto




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#493095; Package mount. (Wed, 11 Feb 2009 21:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to LaMont Jones <lamont@debian.org>:
Extra info received and forwarded to list. (Wed, 11 Feb 2009 21:21:02 GMT) Full text and rfc822 format available.

Message #54 received at 493095@bugs.debian.org (full text, mbox):

From: LaMont Jones <lamont@debian.org>
To: Ken Chase <m-bugs.debian.org@sizone.org>, 493095@bugs.debian.org
Subject: Re: Bug#493095: no solution for diskless workstations
Date: Wed, 11 Feb 2009 14:19:36 -0700
On Wed, Feb 11, 2009 at 11:07:04AM -0500, Ken Chase wrote:
> Cant deactivate NFS on a diskless box.

So install the new nfs-utils first...  That's all that's required...

> Reality however is that diskless workstations are less than entirely uncommon,
> and a proper solution would be nice. (I mean, pretty much everything else
> works for upgrading on a diskless box - I just did a huge dist-upgrade of 400+
> packages that all worked except mount, why not fix the one package?)

Installing portmapper on every machine in existance regardless of
whether or not it has NFS on it (and therefore adding a new listening
service that most users/admins won't even know is there) is also very
much not an option.

Sadly, the only space in between is to let you do the upgrade, and then
not have any of your NFS mounts the next time you boot.

lamont




Information forwarded to debian-bugs-dist@lists.debian.org, LaMont Jones <lamont@debian.org>:
Bug#493095; Package mount. (Wed, 11 Feb 2009 22:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ken Chase <m-bugs.debian.org@sizone.org>:
Extra info received and forwarded to list. Copy sent to LaMont Jones <lamont@debian.org>. (Wed, 11 Feb 2009 22:03:02 GMT) Full text and rfc822 format available.

Message #59 received at 493095@bugs.debian.org (full text, mbox):

From: Ken Chase <m-bugs.debian.org@sizone.org>
To: 493095@bugs.debian.org, LaMont Jones <lamont@debian.org>
Subject: Re: Bug#493095: no solution for diskless workstations
Date: Wed, 11 Feb 2009 17:02:26 -0500
On Wed, Feb 11, 2009 at 02:19:36PM -0700, LaMont Jones's all...
  >On Wed, Feb 11, 2009 at 11:07:04AM -0500, Ken Chase wrote:
  >> Cant deactivate NFS on a diskless box.
  >
  >So install the new nfs-utils first...  That's all that's required...

  >Installing portmapper on every machine in existance regardless of
  >whether or not it has NFS on it (and therefore adding a new listening
  >service that most users/admins won't even know is there) is also very
  >much not an option.
  >
  >Sadly, the only space in between is to let you do the upgrade, and then
  >not have any of your NFS mounts the next time you boot.

Well I sadly dont have a snapshot there of what was required to be done to
upgrade - I dont think the dependency tree would have let me install nfs-utils
without dragging in a ton of other stuff (was dist-up'ing a very old sid) -
perhaps with a force-depends in place it would have worked -- at risk tho, but
now we're getting into advanced tricks here. Ease of use when it doesn't cost
alot of effort seems apt as a general policy.

Im not sure of the solution other than portmapper, but all i did
was hack my mtab for a few seconds to remove nfs, run the install mount,
and put it back. Possibly could break stuff, but it's not like my mount
options are going to change for NFS root on a diskless box. What's required
in the install scripts to do the functional equivalent for checking
diskless setups where mount options are not going to change anyway?

I don't know what the debian policy for supporting diskless setups is,
but if we're 99% the way there already, seems sad to have one package
break it to a level that requires rocket surgery by 31337-level admins only.

/kc
-- 
Ken Chase - ken@heavycomputing.ca - 416 897 6284
Heavy Computing - Clueful Server Colocation at 151 Front St. W Toronto




Forcibly Merged 493095 498350 501480. Request was from LaMont Jones <lamont@debian.org> to control@bugs.debian.org. (Fri, 12 Jun 2009 16:48:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 09:29:21 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.